package go_handler_template

const ServiceProductionPipeline = `
kind: pipeline
type: docker
name: 部署production-service-{{ .Name }}.{{ .NameSpace }}

steps:
  - name: build
    image: plugins/docker
    volumes:
      - name: docker
        path: /var/run/docker.sock
    settings:
      username: {{ .Reg.Username }}
      password: {{ .Reg.Password }}
      repo: {{ .Reg.Registry }}/{{ .NameSpace }}/service-{{ .Name }}
      registry: {{ .Reg.Registry }}
      tags:
        - "${DRONE_TAG}"
        - latest
      dockerfile: ./{{ .Root }}/Dockerfile
      purge: false

  - name: deploy
    image: bitsbeats/drone-helm3
    settings:
      kube_api_server: {{ .Kube.KubeApiServer }}
      kube_token: {{ .Kube.KubeToken }}
      kube_certificate: {{ .Kube.KubeCertificate }}
      chart: ./{{ .Root }}/deploy
      release: service-{{ .Name }}
      wait: true
      namespace: {{ .NameSpace }}
      values:
        - nameSpace={{ .NameSpace }}
        - aliasName={{ .AliasName }}
        - image={{ .Reg.Registry }}/{{ .NameSpace }}/service-{{ .Name }}
        - imageTag=${DRONE_TAG}
        - port={{ .Port }}

volumes:
  - name: docker
    host:
      path: /var/run/docker.sock
`
